//+------------------------------------------------------------------+
//|                                                   AntiError.mq4  |
//|                                   Copyright  -2007, favoritefx  |
//|                                              favoritefx@mail.ru  |
//+------------------------------------------------------------------+
#property copyright "favoritefx"
#property link "favoritefx@mail.ru"
//       
// written by komposter
#include <TradeContext.mqh>
//   
extern double MACDOpenLevel = 3;
extern double MACDCloseLevel = 2;
extern double MATrendPeriod = 26;
//   
int slippage = 3;
//   
int deals = 0;
//     
int TimeForSleep = 10;
//  
int time_for_action = 1;
//   / 
int count = 5;
//   
bool Trade = true;
//      
bool NoOpen = false;
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
bool ServerWork()
  {     
   if(DayOfWeek() == 0 || DayOfWeek() == 6)
       return(false);
   return(true);      
  }
//+------------------------------------------------------------------+
//|  magik                                                  |
//+------------------------------------------------------------------+ 
int GenericMagik()
  {
   return(deals);
  }
//+------------------------------------------------------------------+   
//|                                                    |
//+------------------------------------------------------------------+
bool CloseOrder(int magik)
  {
   int ticket,i;
   double Price_close;
   int err;
   int N;
//      count ,     
// ,       
   while(N < count)
     {          
       for(i = OrdersTotal() - 1; i >= 0; i--) 
         {
           if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
               if(OrderSymbol() == Symbol()) 
                   if(OrderMagicNumber() == magik)
                     {
                       if(OrderType() == OP_BUY)        
                           Price_close = NormalizeDouble(Bid, Digits);
                       if(OrderType() == OP_SELL)        
                           Price_close = NormalizeDouble(Ask, Digits);
                       if(OrderClose(OrderTicket(), OrderLots(),
                          Price_close,slippage))
                         { 
                           //      
                           deals--;
                           //    -   
                           // 
                           NoOpen = false;                           
                           return(true);
                         }
                         //    ,    
                       N++;
                       //   
                       err = ErrorBlock();
                       //   
                       if(err > 1)
                         {
                           Print("    ",
                                 OrderTicket());
                           return(false);
                         }
                     }                                          
         }
        //  5      
       Sleep(5000);
       RefreshRates();
     }
    //     ,      count  
   Print("    ", OrderTicket());
   return(false);
  }
//+------------------------------------------------------------------+
//|  act 1-, 2-,   - -        |
//+------------------------------------------------------------------+ 
int Deal(int act, double Lot)
  {
   int N = 0;
   int ticket;
   int err;
   double Price_open;
   double Lots;
   int cmd;
   int magik;
   magik = GenericMagik();
   Lots = NormalizeDouble(Lot,1);
   if(act == 1)
     {
       Price_open = NormalizeDouble(Ask, Digits);
       cmd = OP_BUY;
     }
   if(act == 2)
     {
       Price_open = NormalizeDouble(Bid, Digits);
       cmd = OP_SELL;
     }
//     
   AccountFreeMarginCheck(Symbol(), cmd,Lots);
   err = GetLastError();
   if(err>0)
     {
       Print("No money for new position");
       NoOpen = true;
       return(0);
     }      
//                    
   ticket = OrderSend(Symbol(), cmd, Lots, Price_open, slippage, 
                      0, 0, 0, magik);
   if(ticket > 0)
     {
       deals++;
       return(ticket);
     }
//   ,   5          
   else
     {
       while(N < count)
         {
           N++;
           err = ErrorBlock();
           if(err == 1)
             {
               Sleep(5000);
               RefreshRates();
               if(act == 1)
                   Price_open = NormalizeDouble(Ask, Digits);
               if(act == 2)
                   Price_open = NormalizeDouble(Bid, Digits);              
               ticket = OrderSend(Symbol(), cmd, Lots, Price_open,
                                  slippage, 0, 0, 0, magik);
               if(ticket > 0)
                 {
                   deals++;
                   return(ticket);
                 }
             }
           //     
           if(err > 1)            
               return(0);               
         }                                                       
     }    
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                |
//| 0- , 1-   , 2- ,      |
//|    3-                                             |
//+------------------------------------------------------------------+
int ErrorBlock()
  {
   int err = GetLastError();
   switch(err)
     {
       case 0: return(0);
       case 2:
         {
           Print(" .  / ");
           Trade = false;
           return(3);  
         }
       case 3:
         {
           Print("   ");
           Trade = false;
           return(3);   
         }
       case 4:
         {
           Print("  .  2 ");
           Sleep(120000);
           return(2);   
         }
       case 6:
         { 
           bool connect = false;
           int iteration = 0;
           Print("Disconnect ");
           while((!connect) || (iteration > 60))
             {
               Sleep(10000);
               Print("  ,  ", iteration*10,
                     "  ");
               connect = IsConnected();
               if(connect)
                 {
                   Print(" ");
                   return(2);
                 }
               iteration++;
             }
           Trade = false; 
           Print("  ");
           return(3);
         }
       case 8:
         {
           Print(" ");
           Trade = false; 
           return(3);
         }
       case 64:
         {
           Print(" !");
           Trade = false; 
           return(3);            
         }
       case 65:
         {
           Print("  ???");
           Trade = false; 
           return(3);            
         }
       case 128:
         {
           Print("   ");
           return(2);
         }
       case 129:
         {
           Print(" ");
           return(1);            
         }
       case 130:
         {
           Print(" ");
           return(1);
         }
       case 131:
         {
           Print("   ");
           Trade = false;            
           return(3);
         }
       case 132:
         {
           Print(" ");
           NoOpen = true;  
           return(2);
         }
       case 134:
         {
           Print("     ");
           Trade = false;             
           return(2);
         }
       case 135:
         {
           Print(" ");
           return (1);
         }
       case 136:
         {
           Print(" !");
           return(2);
         }
       case 138:
         {
           Print(", !");
           return(1);
         }
       case 139:
         {
           Print("  .  ");
           return(2);
         }
       case 141:
         {
           Print("  ");
           Trade = false; 
           return(3);            
         }
       case 148:
         {
           Print("   ");
           NoOpen = true; 
           return(2);            
         }                                          
     }
   return (0);
  }
//+------------------------------------------------------------------+
//|    /   Macd       |
//+------------------------------------------------------------------+
int GetAction(int &action, double &lot, int &magik)
  {
   double MacdCurrent, MacdPrevious, SignalCurrent;
   double SignalPrevious, MaCurrent, MaPrevious;
   int cnt, total;
//----   
   MacdCurrent = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_MAIN, 0);
   MacdPrevious = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_MAIN, 1);
   SignalCurrent = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_SIGNAL, 0);
   SignalPrevious = iMACD(NULL, 0, 12, 26,9, PRICE_CLOSE, MODE_SIGNAL, 1);
   MaCurrent = iMA(NULL, 0, MATrendPeriod, 0, MODE_EMA, PRICE_CLOSE, 0);
   MaPrevious = iMA(NULL, 0, MATrendPeriod, 0, MODE_EMA, PRICE_CLOSE, 1);
//----
   if(MacdCurrent < 0 && MacdCurrent > SignalCurrent && 
      MacdPrevious < SignalPrevious && MathAbs(MacdCurrent) > 
      (MACDOpenLevel*Point) && MaCurrent>MaPrevious)
     {
       action = 1;
       lot = 1;
       return(0);
     }
   if(MacdCurrent > 0 && MacdCurrent < SignalCurrent && 
      MacdPrevious > SignalPrevious && 
      MacdCurrent>(MACDOpenLevel*Point) && MaCurrent < MaPrevious)
     {
       action = 2;
       lot = 1;
       return(0);               
     }
   total = OrdersTotal();
   for(cnt = 0; cnt < total; cnt++)
     {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if(OrderType() <= OP_SELL &&   // check for opened position 
          OrderSymbol() == Symbol())  // check for symbol
         {
           if(OrderType() == OP_BUY)   // long position is opened
             {
               // should it be closed?
               if(MacdCurrent > 0 && MacdCurrent < SignalCurrent && 
                  MacdPrevious > SignalPrevious &&
                  MacdCurrent > (MACDCloseLevel*Point))
                 {
                   action = 3;
                   magik = OrderMagicNumber();
                   return(0); // exit
                 }
             }
           else // go to short position
             {
               // should it be closed?
               if(MacdCurrent < 0 && MacdCurrent > SignalCurrent &&
                  MacdPrevious < SignalPrevious && 
                  MathAbs(MacdCurrent) > (MACDCloseLevel*Point))
                 {
                   action = 3;
                   magik = OrderMagicNumber();
                   return(0); 
                 }
             }
         }
     }
  }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  { 
   if(!IsTradeAllowed())
     {
       Print("  !");
       return(0);     
     }
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//  
   for(int k = OrdersTotal() - 1; k >= 0 ; k--)
       if(OrderSymbol() == Symbol()) 
         {
           if(OrderType() == OP_BUY)
              OrderClose(OrderTicket(), OrderLots(), 
                         NormalizeDouble(Bid,Digits), 10);               
           if(OrderType() == OP_SELL)
               OrderClose(OrderTicket(), OrderLots(),
                          NormalizeDouble(Ask, Digits),10);                 
         }
  } 
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   int action =0;
   double lot = 1;
   int magik = 0;     
   while(Trade)
     {
       Sleep(time_for_action*1000);      
       RefreshRates();
       /* ,     , 
        
        magik   
       action 1-buy, 2-sell, 3-close
            Macd*/
       GetAction(action, lot, magik);
       if(ServerWork())
         {
           if(((action == 1) || (action == 2)) && (!NoOpen))
             {                                        
               if(TradeIsBusy() < 0) 
                   return(-1); 
               Deal(action, lot);
               Sleep(TimeForSleep*1000);                                
               TradeIsNotBusy();
             }
           if(action == 3)
             {
               if(TradeIsBusy() < 0) 
                   return(-1); 
                if(!CloseOrder(magik))
                     {
                       Print("   ");
                       Sleep(TimeForSleep*1000);   
                       TradeIsNotBusy();
                     } 
             }
         }
       else
         {
            Print("");
            if(TradeIsBusy() < 0) 
                  return(-1); 
            Sleep(1000*3600*48);
            TradeIsNotBusy();
         }
       action = 0;
       lot = 0;
       magik = 0;
     }
   Print("       ");  
   return(0);
  }
//+------------------------------------------------------------------+